

<!DOCTYPE html>
<html lang="en">

<head>
  
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title> models/board.model.js</title>

  <script src="https://cdn.jsdelivr.net/gh/google/code-prettify@master/loader/run_prettify.js"></script>
  <script src="https://unpkg.com/@babel/standalone/babel.min.js"></script>
  <script src="./build/entry.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <!--[if lt IE 9]>
    <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
  <![endif]-->
  <link href="https://fonts.googleapis.com/css?family=Roboto:100,400,700|Inconsolata,700" rel="stylesheet">
  <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.3/css/all.css" integrity="sha384-UHRtZLI+pbxtHCWp1t77Bi1L4ZtiqrqD80Kn4Z8NTSRyMA2Fd33n5dQ8lWUE00s/" crossorigin="anonymous">
  <link type="text/css" rel="stylesheet" href="https://jmblog.github.io/color-themes-for-google-code-prettify/themes/tomorrow-night.min.css">
  <link type="text/css" rel="stylesheet" href="styles/app.min.css">
  <link type="text/css" rel="stylesheet" href="styles/iframe.css">
  <link type="text/css" rel="stylesheet" href="">
  <script async defer src="https://buttons.github.io/buttons.js"></script>

  
</head>



<body class="layout small-header">
    <div id="stickyNavbarOverlay"></div>
    

<div class="top-nav">
    <div class="inner">
        <a id="hamburger" role="button" class="navbar-burger" aria-label="menu" aria-expanded="false">
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
            <span aria-hidden="true"></span>
        </a>
        <div class="logo">
            
            
        </div>
        <div class="menu">
            
            <div class="navigation">
                <a
                    href="index.html"
                    class="link"
                >
                    API Documentation
                </a>
                
                
                
            </div>
        </div>
    </div>
</div>
    <div id="main">
        <div
            class="sidebar "
            id="sidebarNav"
        >
            
            <nav>
                
                    <h2><a href="index.html">Documentation</a></h2><div class="category"><h3>Classes</h3><ul><li><a href="Board.html">Board</a></li><li><a href="Task.html">Task</a></li></ul><h3>Global</h3><ul><li><a href="global.html#status">status</a></li></ul></div>
                
            </nav>
        </div>
        <div class="core" id="main-content-wrapper">
            <div class="content">
                <header class="page-title">
                    <p>Source</p>
                    <h1>models/board.model.js</h1>
                </header>
                



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import { Task } from './task.model.js';

/** The Board class holds tasks */
export class Board {
  #tasks;
  static taskCount;

  /**
  * Creates an instance of the Board class.
  */
  constructor() {
    this.#tasks = [];
    Board.taskCount = 0;
  }

  /**
     * Gets an array of tasks on the board.
     * @returns {Task[]} An array of tasks.
     */
  get tasks() {
    return this.#tasks.map((task) => task);
  }

  /**
   * Gets the number of tasks on the board.
   * @returns {number} The number of tasks.
   */
  get taskCount() {
    return Board.taskCount;
  }

  /**
   * Adds a new task to the board.
   * @param {Task} task - The task to be added.
   * @throws {Error} If the argument is not an instance of the Task class or if the task is already in the board.
   */
  add(task) {
    if (!(task instanceof Task)) {
      throw new Error('Only instances of Task class can be added to the board.');
    }
    if (this.#tasks.includes(task)) {
      throw new Error('This task is already in tasks.');
    }

    this.#tasks.push(task);
    Board.taskCount++; // Increment taskCount by 1
  }

  /**
   * Removes a task from the board.
   * @param {Task} task - The task to be removed.
   * @throws {Error} If the task does not exist in the board.
   */
  remove(task) {
    const taskIndex = this.#tasks.indexOf(task);

    if (taskIndex &lt; 0) {
      throw Error('This task does not exist. Cannot remove!');
    }

    this.#tasks.splice(taskIndex, 1);
    Board.taskCount--; // Decrement taskCount by 1
  }

  /**
  * Transforms the board data into a formatted string.
  * @returns {string} A formatted string representing the board data.
  */
  toString() {
    const titles = '---Task Board---\n\nTasks:\n\n';

    if (this.#tasks.length) {
      return titles + this.#tasks.join('\n--------\n');
    }

    return `${titles}No tasks at the moment.`;
  }
}</code></pre>
        </article>
    </section>




            </div>
            
            <footer class="footer">
                <div class="content has-text-centered">
                    <p>Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a></p>
                    <p class="sidebar-created-by">
                        <a href="https://github.com/SoftwareBrothers/better-docs" target="_blank">BetterDocs theme</a> provided with <i class="fas fa-heart"></i> by 
                        <a href="http://softwarebrothers.co" target="_blank">SoftwareBrothers - JavaScript Development Agency</a>
                    </p>
                </div>
            </footer>
            
        </div>
        <div id="side-nav" class="side-nav">
        </div>
    </div>
<script src="scripts/app.min.js"></script>
<script>PR.prettyPrint();</script>
<script src="scripts/linenumber.js"> </script>

</body>
</html>
